﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Diagram;
namespace TextNodeSample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            propertyEditor1.Diagram = this.diagram1;
        }

        private void Form1_Load(object sender, EventArgs e)
        {            
            TextNode textnode = new TextNode("HI WELCOME",new RectangleF(100,100,100,50));
            diagram1.Model.AppendChild(textnode);
            diagram1.View.SelectionList.Clear();
            diagram1.EventSink.NodeDoubleClick += EventSink_NodeDoubleClick;
        }

        void EventSink_NodeDoubleClick(NodeMouseEventArgs evtArgs)
        {
            Node node = evtArgs.Node;
            if (node is TextNode)
            {
                Form2 Diaglog = new Form2();
                Diaglog.NodeText = ((TextNode)node).Text;
                ((TextNode)node).Text = "";

                if (Diaglog.ShowDialog(this) == DialogResult.OK)
                {
                    TextNode tn = node as TextNode;
                    diagram1.Controller.TextEditor.EndEdit(false);
                    tn.Text = Diaglog.NodeText;
                    using (Graphics gp = Graphics.FromHwnd(IntPtr.Zero))
                    {
                        SizeF size = gp.MeasureString(tn.Text, tn.FontStyle.CreateFont());
                        tn.SizeToText(size);
                    }
                }
            }
        }
    }
}
