﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TextNodeSample
{
    public partial class Form2 : Form
    {
        public string NodeText
        {
            get
            {
                return this.txtNodeText.Text;
            }
            set
            {
                if (value != this.txtNodeText.Text)
                    this.txtNodeText.Text = value;
            }
        }

        public Form2()
        {
            InitializeComponent();
        }

        private void btnOk_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            this.Close();
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            this.Close();
        }

        private void Form2_Load(object sender, EventArgs e)
        {
            this.txtNodeText.Focus();
        }

    }
}
